require 'redshift_connector/reader/abstract'
require 'redshift_connector/reader/exception'
require 'redshift_csv_file'
require 'forwardable'

module RedshiftConnector
  # Reads CSV file generated by Redshift UNLOAD statement (with option ADDQUOTES ESCAPE).
  # UNLOAD escapes data by '\' (backslash character), we cannot use standard CSV class.
  class Reader::RedshiftCSV < Reader::Abstract
    declare_reader :redshift_csv

    def self.data_object?(key)
      /\.csv(?:\.|\z)/ =~ File.basename(key)
    end

    # f :: IO
    def initialize(f)
      @f = f
      @csv = RedshiftCsvFile.new(@f)
    end

    extend Forwardable
    def_delegators '@csv', :each, :each_row, :read_row
  end
end
